package
{
	import adobe.utils.MMExecute;
	
	import com.adobe.serialization.json.JSON;
	import com.bit101.components.PushButton;
	
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.net.Socket;
	
	[SWF(width="250",height="250",frameRate="24",backgroundColor="#aaaaaa")]
	public class NodePainter extends Sprite
	{
		public static const CONNECT_COLOR_RED:int = 0;
		public static const CONNECT_COLOR_GREEN:int = 1;
		
		private var _socket:Socket;
		private var _connectButton:PushButton;
		private var _isconnected:Boolean = false;
		private var _connectCircle:Sprite;
		public const HOST:String = "localhost";
		public const PORT:int = 3000;
		
		public function NodePainter()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			createConnectCircle();
			_connectButton = new PushButton(this, 10, 10, "CONNECT", onConnectClick);
		}
		
		private function onConnectClick(e:MouseEvent):void
		{
			if(_isconnected === false){
				_socket = new Socket();
				_socket.addEventListener(Event.CONNECT, onSocketConnect);
				_socket.addEventListener(ProgressEvent.SOCKET_DATA, onSocketData);
				_socket.connect(HOST, PORT);
				_connectButton.label = "DISCONNECT";
			}else{
				_isconnected = false;
				drawConnectCircle(CONNECT_COLOR_RED);
				_socket.removeEventListener(Event.CONNECT, onSocketConnect);
				_socket.removeEventListener(ProgressEvent.SOCKET_DATA, onSocketData);
				_socket.close();
				_socket = null;
				_connectButton.label = "CONNECT";
			}
		}
		
		protected function onSocketData(event:ProgressEvent):void
		{
			var chars:Array = [],
				char:String,
				msg:String;
			while(_socket.bytesAvailable){
				char = _socket.readUTFBytes(1);
				chars.push(char);
			}
			msg = chars.join('');
			var obj:Object = JSON.decode(msg);
			
			if(obj.type === 'publish'){
				this.publishSwiffy();
				_socket.writeUTF('swiffy complete');
				_socket.flush();
				
			}else{
				this.changeFrame(obj.frame);
				this.changeStroke(obj.stroke.width, obj.stroke.color);
				this.drawStagePath(obj.stroke);
			}
			//trace(obj.width, obj.color, obj.points.length);
		}
		
		private function publishSwiffy():void
		{
			var commands:Array = [];
			commands.push('var path = fl.configURI + "Commands/" + "Export as HTML5 (Swiffy).jsfl";');
			commands.push('fl.runScript(path);');
			MMExecute(commands.join(''));
		}
		
		private function changeStroke(strokeWidth:int, strokeColor:String):void
		{
			var commands:Array = [];
			commands.push('var myStroke = fl.getDocumentDOM().getCustomStroke("toolbar");');
			commands.push('myStroke.color = "'+strokeColor+'";');
			commands.push('fl.getDocumentDOM().setCustomStroke(myStroke);');
			MMExecute(commands.join(''));
		}
		
		private function changeFrame(frameIndex:int):void
		{
			var jsfl:String = "fl.getDocumentDOM().getTimeline().currentFrame = "+frameIndex;
			MMExecute(jsfl);
		}
		
		private function drawStagePath(obj:Object):void
		{
			var commands:Array = [],
				i:int = 0,
				len:int = obj.points.length;
			commands.push('var fill = fl.getDocumentDOM().getCustomFill();');
			commands.push('fill.style= "noFill";');
			commands.push('fl.getDocumentDOM().setCustomFill( fill );');
			commands.push('var myPath = fl.drawingLayer.newPath();');
			
			for(i = 0; i < len; i += 2){
				commands.push('myPath.addPoint('+obj.points[i]+', '+obj.points[i+1]+');');
			}
			commands.push('myPath.makeShape();');
			MMExecute(commands.join(''));
		}
		
		protected function onSocketConnect(event:Event):void
		{
			_isconnected = true;
			drawConnectCircle(CONNECT_COLOR_GREEN);
		}
		
		private function createConnectCircle():void
		{
			_connectCircle = new Sprite();
			_connectCircle.x = 120;
			_connectCircle.y = 15;
			addChild(_connectCircle);
			drawConnectCircle(CONNECT_COLOR_RED);
		}
		
		private function drawConnectCircle(colorType:int):void
		{
			var color:int, 
				g:Graphics = _connectCircle.graphics;
			
			if(colorType === CONNECT_COLOR_RED){
				color = 0xFF0022;
				
			}else if(colorType === CONNECT_COLOR_GREEN){
				color = 0x74D062;
			}
			g.clear();
			g.lineStyle(1,0x888888,0.5);
			g.beginFill(color,1);
			g.drawCircle(5, 5, 5);
			g.endFill();
		}
	}
}